@use "theme";

@mixin card {
    padding: theme.$spacing05;
    margin-bottom: theme.$spacing05;
    border-radius: theme.$borderRadius;
    box-shadow: theme.$boxShadow;
    background-color: white;
}

@mixin margin-size-responsive($size, $direction) {

    @if $size =='xs' {
        @if $direction =='top' {
            margin-top: theme.$spacing02;

            @media only screen and (min-width: theme.$sm) {
                margin-top: theme.$spacing03;
            }
        }

        @else if $direction =='bottom' {
            margin-bottom: theme.$spacing02;

            @media only screen and (min-width: theme.$sm) {
                margin-bottom: theme.$spacing03;
            }
        }
    }

    @else if $size =='sm' {
        @if $direction =='top' {
            margin-top: theme.$spacing04;

            @media only screen and (min-width: theme.$sm) {
                margin-top: theme.$spacing05;
            }
        }

        @else if $direction =='bottom' {
            margin-bottom: theme.$spacing04;

            @media only screen and (min-width: theme.$sm) {
                margin-bottom: theme.$spacing05;
            }
        }
    }

    @else if $size =='md' {
        @if $direction =='top' {
            margin-top: theme.$spacing05;

            @media only screen and (min-width: theme.$sm) {
                margin-top: theme.$spacing06;
            }
        }

        @else if $direction =='bottom' {
            margin-bottom: theme.$spacing05;

            @media only screen and (min-width: theme.$sm) {
                margin-bottom: theme.$spacing06;
            }
        }
    }

    @else if $size =='lg' {
        @if $direction =='top' {
            margin-top: theme.$spacing07;

            @media only screen and (min-width: theme.$sm) {
                margin-top: theme.$spacing09;
            }
        }

        @else if $direction =='bottom' {
            margin-bottom: theme.$spacing07;

            @media only screen and (min-width: theme.$sm) {
                margin-bottom: theme.$spacing09;
            }
        }
    }

    @else if $size =='xl' {
        @if $direction =='top' {
            margin-bottom: theme.$spacing08;

            @media only screen and (min-width: theme.$sm) {
                margin-bottom: theme.$spacing10;
            }
        }

        @else if $direction =='bottom' {
            margin-bottom: theme.$spacing08;

            @media only screen and (min-width: theme.$sm) {
                margin-bottom: theme.$spacing10;
            }
        }
    }

    @else if $size =='xxl' {
        margin-bottom: theme.$spacing09;

        @media only screen and (min-width: theme.$sm) {
            margin-bottom: theme.$spacing11;
        }
    }

    @else {
        @error "Unknown size #{$size}.";
    }
}

// Margin top mixins
@mixin margin-top-xs-responsive {
    margin-top: theme.$spacing02;

    @media only screen and (min-width: theme.$sm) {
        margin-top: theme.$spacing03;
    }
}

@mixin margin-top-sm-responsive {
    margin-top: theme.$spacing04;

    @media only screen and (min-width: theme.$sm) {
        margin-top: theme.$spacing05;
    }
}

@mixin margin-top-md-responsive {
    margin-top: theme.$spacing05;

    @media only screen and (min-width: theme.$sm) {
        margin-top: theme.$spacing06;
    }
}

@mixin margin-top-lg-responsive {
    margin-top: theme.$spacing07;

    @media only screen and (min-width: theme.$sm) {
        margin-top: theme.$spacing09;
    }
}

// Margin top and bottom (Y axis) mixins
@mixin margin-y-sm-responsive {
    margin-top: theme.$spacing04;
    margin-bottom: theme.$spacing04;

    @media only screen and (min-width: theme.$sm) {
        margin-top: theme.$spacing05;
        margin-bottom: theme.$spacing05;
    }
}

@mixin margin-y-md-responsive {
    margin-top: theme.$spacing05;
    margin-bottom: theme.$spacing05;

    @media only screen and (min-width: theme.$sm) {
        margin-top: theme.$spacing06;
        margin-bottom: theme.$spacing06;
    }
}

@mixin margin-y-lg-responsive {
    margin-top: theme.$spacing07;
    margin-bottom: theme.$spacing07;

    @media only screen and (min-width: theme.$sm) {
        margin-top: theme.$spacing09;
        margin-bottom: theme.$spacing09;
    }
}


@mixin list-reset {
    padding-left: 0;
    margin-top: 0;
    margin-bottom: 0;
    list-style-type: none;
}

@mixin horizontal-list {
    @include list-reset;
    display: flex;
    flex-wrap: wrap;
    padding: 0;
}

@mixin small-gray-text {
    font-size: theme.$fontSizeSmall;
    color: theme.$colorPaletteGray700;
    line-height: 1;
}
